﻿#include "stdafx.h"
#include "NeMessenger.h"
#include "CallHistoryDlg.h"
#include "NeMessengerDlg.h"

//IMPLEMENT_DYNAMIC(CCallHistoryDlg, CSkinDialog)  //1015(lint)
#define WM_ASYNC_DESTROYWINDOW  (WM_USER + 16)
#define BTN_HEIGHT				36
#define BTN_TEXT_COLOR RGB(94, 95, 109)
CCallHistoryDlg::CCallHistoryDlg(CWnd* pParent /*=NULL*/)
	: CSkinDialog(CCallHistoryDlg::IDD, pParent)
	, m_pActorEvent(new CCallHistoryActorEvent(this))
	, m_pParentDlg((CNeMessengerDlg*)pParent)
{
	m_strSearchText = _T("");
    m_nBorderHeight = 0;
    m_nBorderWidth = 0;
    _clipBoardFormat = 0;
	m_pOKCancelButtons = NULL;
    //m_nHitTest = 0;
    m_rtMemo.SetRectEmpty();
}

CCallHistoryDlg::~CCallHistoryDlg()
{
	SAFE_DELETE(m_pActorEvent);
	m_bmTopBg.DeleteObject();
	m_ImageList.DeleteImageList();
}

void CCallHistoryDlg::DoDataExchange(CDataExchange* pDX)
{
	CSkinDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_CALL, m_lcCallHistory);
	DDX_Control(pDX, IDC_EDIT_MEMO, m_editMemo);
	DDX_Control(pDX, IDC_BTN_CALL_TYPE_ALL, m_btnTypeAll);
	DDX_Control(pDX, IDC_BTN_CALL_TYPE_SEND, m_btnTypeSend);
	DDX_Control(pDX, IDC_BTN_CALL_TYPE_RECV, m_btnTypeRecv);
	DDX_Control(pDX, IDC_BTN_CALL_TYPE_ABSENT, m_btnTypeAbsent);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_cbSearchType);
}


BEGIN_MESSAGE_MAP(CCallHistoryDlg, CSkinDialog)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_CALL, &CCallHistoryDlg::OnLvnItemchangedListCall)
	ON_BN_CLICKED(IDC_BTN_CALL_TYPE_ALL, &CCallHistoryDlg::OnBnClickedBtnCallTypeAll)
	ON_BN_CLICKED(IDC_BTN_CALL_TYPE_SEND, &CCallHistoryDlg::OnBnClickedBtnCallTypeSend)
	ON_BN_CLICKED(IDC_BTN_CALL_TYPE_RECV, &CCallHistoryDlg::OnBnClickedBtnCallTypeRecv)
	ON_BN_CLICKED(IDC_BTN_CALL_TYPE_ABSENT, &CCallHistoryDlg::OnBnClickedBtnCallTypeAbsent)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


BOOL CCallHistoryDlg::OnInitDialog()
{
	CSkinDialog::OnInitDialog();

	m_nBorderHeight = (GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYFRAME));
	m_nBorderWidth = GetSystemMetrics(SM_CXFRAME);

	//ModifyStyle(DS_MODALFRAME, WS_THICKFRAME);
	ModifyStyle(0, WS_CLIPCHILDREN);
	ModifyStyle(WS_MAXIMIZEBOX, 0);

	__ResourceLoad(TRUE);

	// 리스트 컬럼 Width
	int colWidthList[] = {
		24,		// Icon
		150,	// 일시
		86,		// 발신번호
		86,		// 수신번호
		90,		// 메모
		-1
	};

	// 리스트 컬럼 헤더 제목
	CStringArray arrListHeaderTitle;
	arrListHeaderTitle.Add(_T(""));	// Icon
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING361));	// 일시
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING362));	// 발신번호
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING363));	// 수신번호
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING364));	// 메모

	InitList(m_lcCallHistory, arrListHeaderTitle);
	ResizeListColumn(m_lcCallHistory, colWidthList);

	// 리스트에 사용할 이미지 리스트
	if (m_ImageList.Create(18, 18, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 3, 3))
	{
		COLORREF crMask = RGB(0, 0, 0);

		CBitmap bmStatus[3];

		LoadBitmapFromPath(bmStatus[0], GetAppImgFile(_T("Calltype_send.png")));
		LoadBitmapFromPath(bmStatus[1], GetAppImgFile(_T("Calltype_recv.png")));
		LoadBitmapFromPath(bmStatus[2], GetAppImgFile(_T("Calltype_absent.png")));

		m_ImageList.Add(&bmStatus[0], crMask);
		m_ImageList.Add(&bmStatus[1], crMask);
		m_ImageList.Add(&bmStatus[2], crMask);

		bmStatus[0].DeleteObject();
		bmStatus[1].DeleteObject();
		bmStatus[2].DeleteObject();
	}
	m_lcCallHistory.SetImageList(&m_ImageList, LVSIL_SMALL);

	// 상단 검색 에디트/버튼
	CString strTmpClassName;
	strTmpClassName.Format(_T("Ntalk_CallHistory_Search_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());
	RegisterWindowClass(strTmpClassName);

	CRect rtWorkSearch(0, 0, 0, 0);
	if (m_wndSearch.Create(strTmpClassName, _T("Ntalk_Callhistory_Search"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS, rtWorkSearch, this, ID_CALL_HISTORY_SEARCH))
	{
		m_wndSearch.SetImgBGPath(_T("Main_searchform_bg.png"));
		m_wndSearch.SetImgSearchPath(_T("New_Info_Search.png"), _T("New_Info_Search_Over.png"), _T("New_Info_Search_Click.png"));
		m_wndSearch.SetDefaultText(LoadStringFromResource(IDS_STRING245));

		if (m_strSearchText.IsEmpty())
			m_wndSearch.SetIntroducingText();	// 검색어를 입력해주세요.
		else 
			m_wndSearch.SetIntroducingText(m_strSearchText);

		m_wndSearch.SetSearchText(m_strSearchText);
		m_wndSearch.SetResetSearchText(FALSE);		// 검색 후 검색어를 초기화 하지 않음
		m_wndSearch.SetEditFont(&g_ftDefault9PT);
		m_wndSearch.SetEditBkColor(RGB(255, 255, 255));
	}

	m_cbSearchType.AddString(LoadStringFromResource(IDS_STRING370));	// 전체
	m_cbSearchType.AddString(LoadStringFromResource(IDS_STRING371));	// 발신전화
	m_cbSearchType.AddString(LoadStringFromResource(IDS_STRING372));	// 수신전화
	m_cbSearchType.AddString(LoadStringFromResource(IDS_STRING373));	// 부재중
	m_cbSearchType.SetCurSel(0);

	m_cbSearchType.SetFont(&g_ftDefault9PT);	// 폰트 크기를 13PX로 하면 XP에서 콤보박스가 동작하지 않는 문제가 있다. (눌러도 펼쳐지지 않음)

	m_editMemo.SetFont(&g_ftDefault9PT);

	// 메인창 보더 색
	m_penBorder.CreatePen(PS_SOLID, 1, COLOR_LIST_BORDER);

	// 캡션바 아래의 그라데이션 배경 이미지
	LoadBitmapFromPath(m_bmTopBg, GetAppImgFile(_T("frame_B_bg.png")));

	_clipBoardFormat = RegisterClipboardFormat(_T("CF_NTALK_ID"));

	MoveWindow(0, 0, CH_DLG_MIN_X, CH_DLG_MIN_Y);

	//GET_APP()->SetWindowRegion(this);

	SetSkin();
	ReSizeCtrl();

	SetLastPosition(this, _T("CallHistoryDialog"));
	RedrawWindow();

	OnBnClickedBtnCallTypeAll();

	return TRUE;  // return TRUE unless you set the focus to a control
	// 예외: OCX 속성 페이지는 FALSE를 반환해야 합니다.
}

void CCallHistoryDlg::__ResourceLoad(BOOL bInit)
{
	CString strRes;	
	int nCurSel = 0;

	if (bInit)
	{
		SetWindowText(LoadStringFromResource(IDS_STRING360));
		SetShowTitle(FALSE);
		SetDialogShowWindowText(true);
		SetDialogWindowText(LoadStringFromResource(IDS_STRING360));
		SetWindowTextColor(CColorConvert::HEX2Color(0xFFC8D1D8));
		SetWindowTextFontHeight(12);

		SetLeftTopPNG(GetAppImgFile(_T("img_title_l.png")));
		SetCenterTopPNG(GetAppImgFile(_T("img_title_c.png")));
		SetRightTopPNG(GetAppImgFile(_T("img_title_r.png")));

		SetLeftBorderBitmap(GetAppImgFile(_T("new_02_left.bmp")));
		SetRightBorderBitmap(GetAppImgFile(_T("new_02_right.bmp")));

		SetLeftBottomPNG(GetAppImgFile(_T("img_bottom_l.png")));
		SetCenterBottomPNG(GetAppImgFile(_T("img_bottom_c.png")));
		SetRightBottomPNG(GetAppImgFile(_T("img_bottom_r.png")));
		SetUserBottomPNGBK(GetAppImgFile(_T("btn_popup_org_c_nor.png")));
		SetUserBottomPNG(GetAppImgFile(_T("btn_popup_org_bar.png")));

		SetExitBitmaps(GetAppImgFile(_T("btn_common_cancel_nor.bmp")),
			GetAppImgFile(_T("btn_common_cancel_foc.bmp")), GetAppImgFile(_T("btn_common_cancel_pre.bmp")));
		SetCloseEvent(TRUE);

		m_btnTypeAll.SetBtnBitmapFile(GetAppImgFile(_T("btn_note_01.bmp")),RGB(255,0,255));
		m_btnTypeAll.SetBmpText(LoadStringFromResource(IDS_STRING370));
		m_btnTypeAll.SetBmpFont(&g_ftDefault9PT);
		m_btnTypeAll.SetBmpFontColor(BTN_TEXT_COLOR);
		m_btnTypeAll.EnableHandCursor(TRUE);

		m_btnTypeSend.SetBtnBitmapFile(GetAppImgFile(_T("btn_note_02.bmp")),RGB(255,0,255));
		m_btnTypeSend.SetBmpText(LoadStringFromResource(IDS_STRING371));
		m_btnTypeSend.SetBmpFont(&g_ftDefault9PT);
		m_btnTypeSend.SetBmpFontColor(BTN_TEXT_COLOR);
		m_btnTypeSend.EnableHandCursor(TRUE);

		m_btnTypeRecv.SetBtnBitmapFile(GetAppImgFile(_T("btn_note_02.bmp")),RGB(255,0,255));
		m_btnTypeRecv.SetBmpText(LoadStringFromResource(IDS_STRING372));
		m_btnTypeRecv.SetBmpFont(&g_ftDefault9PT);
		m_btnTypeRecv.SetBmpFontColor(BTN_TEXT_COLOR);
		m_btnTypeRecv.EnableHandCursor(TRUE);

		m_btnTypeAbsent.SetBtnBitmapFile(GetAppImgFile(_T("btn_note_03.bmp")),RGB(255,0,255));
		m_btnTypeAbsent.SetBmpText(LoadStringFromResource(IDS_STRING373));
		m_btnTypeAbsent.SetBmpFont(&g_ftDefault9PT);
		m_btnTypeAbsent.SetBmpFontColor(BTN_TEXT_COLOR);
		m_btnTypeAbsent.EnableHandCursor(TRUE);
	}

	if (g_stNtalkInfo.nLang == NTALK_LANG_KOREAN) //kor
	{
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_ENGLISH) //eng
	{
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_JAPANESE)
	{
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_TRADITIONAL)
	{
	}
	else if(g_stNtalkInfo.nLang == NTALK_LANG_CHINESE_SIMPLIFIED)
	{
	}

}

void CCallHistoryDlg::InitList(CNListCtrl &list, CStringArray &strHeaderTitle)
{
	LV_COLUMN lvcolumn;
	memset(&lvcolumn, 0, sizeof(lvcolumn));
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_MINWIDTH;

	for (int i = 0; i < strHeaderTitle.GetCount(); i++)
	{
		lvcolumn.fmt = LVCFMT_LEFT;
		lvcolumn.pszText = (LPTSTR)(LPCTSTR)strHeaderTitle.GetAt(i);
		lvcolumn.iSubItem = i;
		lvcolumn.cxMin = 0;
		list.InsertColumn(i, &lvcolumn);
	}

	list.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_DOUBLEBUFFER);
	list.SetRowHeight(20);			// 리스트 아이템 높이 설정
	list.SetTextFont(&g_ftDefault9PT);	// 리스트 폰트 설정
	list.GetHeaderCtrl()->SetFont(&g_ftDefault9PT);
}

void CCallHistoryDlg::ResizeListColumn(CNListCtrl &list, const int *arrWidth)
{
	std::list<int> freezeColList;
	std::list<int> linkColList;

	for (int i = 0; arrWidth[i] != -1; i++)
	{
		list.SetColumnWidth(i, arrWidth[i]);

		if (arrWidth[i] == 0)
			freezeColList.push_back(i);
	}

	list.SetImageColumn(0);
	list.SetFreezeColumns(freezeColList);		// Width가 0인 컬럼은 Freesze 시킨다
	list.RedrawWindow();
}

void CCallHistoryDlg::SetSkin()
{
	/*CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("AddUserDlg.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);*/
}

void CCallHistoryDlg::ReSizeCtrl(void)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);	

	// Search Window
	if (m_cbSearchType.GetSafeHwnd() && m_wndSearch.GetSafeHwnd())
	{
		int nImgWidth = m_wndSearch.GetImgBGWidth();
		int nImgHeight = m_wndSearch.GetImgBGHeight();

		CRect rtSearch(0, 0, 0, 0);
		rtSearch.top = rcClient.top + 7;
		rtSearch.bottom = rtSearch.top + nImgHeight;
		rtSearch.right = rcClient.right - 11;
		rtSearch.left = rtSearch.right - 261;

		m_wndSearch.MoveWindow(&rtSearch);

		rtSearch.right = rtSearch.left - 10;
		rtSearch.left = rtSearch.right - 100;
		rtSearch.top += 2;
		m_cbSearchType.MoveWindow(&rtSearch);
	}

	// 상단 메뉴 버튼
	if (m_btnTypeAll.GetSafeHwnd() && m_btnTypeSend.GetSafeHwnd() && m_btnTypeRecv.GetSafeHwnd() && m_btnTypeAbsent.GetSafeHwnd())
	{
		CRect rcBtn(0, 0, 0, 0);
		rcBtn.left = 20;
		rcBtn.right = rcBtn.left + CH_DLG_TYPE_BTN_WIDTH;
		rcBtn.top = 54;
		rcBtn.bottom = rcBtn.top + CH_DLG_TYPE_BTN_HEIGHT;

		m_btnTypeAll.MoveWindow(rcBtn, TRUE);

		rcBtn.OffsetRect(CH_DLG_TYPE_BTN_WIDTH + CH_DLG_TYPE_BTN_GAP_X, 0);
		m_btnTypeSend.MoveWindow(rcBtn, TRUE);

		rcBtn.OffsetRect(CH_DLG_TYPE_BTN_WIDTH + CH_DLG_TYPE_BTN_GAP_X, 0);
		m_btnTypeRecv.MoveWindow(rcBtn, TRUE);

		rcBtn.OffsetRect(CH_DLG_TYPE_BTN_WIDTH + CH_DLG_TYPE_BTN_GAP_X, 0);
		m_btnTypeAbsent.MoveWindow(rcBtn, TRUE);
	}

	// 메인 리스트
	if (m_editMemo.GetSafeHwnd() && m_lcCallHistory.GetSafeHwnd())
	{
		m_lcCallHistory.MoveWindow(20, 84, rcClient.Width() - 40, 117, TRUE);
		
		CRect rtEdit(20, 285, rcClient.Width() - 20, 285 + 59);
		m_editMemo.MoveWindow(&rtEdit, TRUE);
		rtEdit.MoveToXY(0, 0);
		rtEdit.DeflateRect(10, 5, 10, 5);
		m_editMemo.SetRect(&rtEdit);
		m_rtMemo.SetRect(20, 221, rcClient.Width() - 20, 284);
		m_rtMemo.InflateRect(1, 1, 1, 1);
	}

	// 버튼 위치
	if(m_pOKCancelButtons && m_pOKCancelButtons->GetHWND())
	{
		CRect rcButtons(rcClient.left, rcClient.bottom+7 - BTN_HEIGHT, rcClient.right, rcClient.bottom + 7);
		m_pOKCancelButtons->SetClientRect(rcButtons);

	}
}

BOOL CCallHistoryDlg::PreTranslateMessage(MSG* pMsg)
{

	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE)
	{
		PostMessage(WM_CLOSE, 0, 0);
		return TRUE;
	}
	if (IsCloseMsg(pMsg))
	{
		if (pMsg->hwnd == this->GetSafeHwnd())
		{
			m_pParentDlg->CloseCallHistoryDlg();
			return TRUE;
		}
	}
	if(pMsg->message == WM_ASYNC_DESTROYWINDOW)
	{
		m_pParentDlg->CloseCallHistoryDlg();
		return TRUE;
	}

	return __super::PreTranslateMessage(pMsg);
}

bool CCallHistoryDlg::IsCloseMsg(MSG* pMsg)
{
	bool result = false;

	if (pMsg->hwnd != this->GetSafeHwnd())
		return false;

	if (pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||									// ALT + F4
		(pMsg->message == WM_SYSCOMMAND && (pMsg->wParam & 0xFFF0) == SC_CLOSE) ||						// 타이틀바 우클릭메뉴 > 닫기
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))	// Close button
	{
		result = true;
	}

	return result;
}

void CCallHistoryDlg::OnSize(UINT nType, int cx, int cy)
{
	__super::OnSize(nType, cx, cy);

	ReSizeCtrl();
	RedrawWindow();
}

void CCallHistoryDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	lpMMI->ptMinTrackSize.x = CH_DLG_MIN_X;
	lpMMI->ptMinTrackSize.y = CH_DLG_MIN_Y;

	__super::OnGetMinMaxInfo(lpMMI);
}


void CCallHistoryDlg::OnPaint()
{
	CPaintDC dc(this);

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(255, 255, 255));	// 대화상자 배경색

	// 상단의 이미지
    BITMAP bitmap = { 0 };
	m_bmTopBg.GetBitmap(&bitmap);

	NMMemDC memBmpDC;
	memBmpDC.CreateCompatibleDC(&dc, bitmap.bmWidth, bitmap.bmHeight);

	CBitmap *pOldBmp = memBmpDC.SelectObject(&m_bmTopBg);
	memDC.StretchBlt(0, 0, rcClient.Width(), bitmap.bmHeight, &memBmpDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCCOPY);
	memBmpDC.SelectObject(pOldBmp);

	// Search wnd 를 메인창 것을 같이 사용하다보니 좌우 라인이 없으므로 그려준다.
	CRect rcSearch(0, 0, 0, 0);
	//m_wndSearch.GetWindowRect(rcSearch);
	////this->ScreenToClient(rcSearch);
	//rcSearch.InflateRect(1, 0, 1, -1);
	//memDC.FillSolidRect(rcSearch.left, rcSearch.top, rcSearch.Width(), rcSearch.Height(), COLOR_LIST_BORDER);

	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	memDC.SelectObject((HBRUSH)GetStockObject(NULL_BRUSH));

	// Listctrl의 배경선
	CRect rcList(0, 0, 0, 0);
	m_lcCallHistory.GetWindowRect(&rcList);
	ScreenToClient(&rcList);
	rcList.InflateRect(1, 1, 1, 1);
	memDC.Rectangle(&rcList);

	CRect rcCombo(0, 0, 0, 0);
	m_cbSearchType.GetWindowRect(rcCombo);
	ScreenToClient(&rcCombo);
	rcCombo.InflateRect(1, 1, 1, 1);
	memDC.Rectangle(&rcCombo);

	// 메모내용 박스
	memDC.FillSolidRect(&m_rtMemo, CH_DLG_COLOR_MEMO_BG1);

	CRect rtEdit(0, 0, 0, 0);
	rtEdit.CopyRect(&m_rtMemo);
	rtEdit.bottom = rtEdit.top + 125;
	memDC.Rectangle(&rtEdit);

	CFont *pOldFont = memDC.SelectObject(&g_ftDefault9PT);
	memDC.SetBkMode(TRANSPARENT);

	if (m_lcCallHistory.GetSelectedCount() == 1)
	{
		POSITION pos = m_lcCallHistory.GetFirstSelectedItemPosition();
		int nSel = m_lcCallHistory.GetNextSelectedItem(pos);

		NE_CALL_DATA* pCallData = (NE_CALL_DATA*)m_lcCallHistory.GetItemData(nSel);

		if (pCallData)
		{
			CRect rtText(30, 234, 480, 254);
            CSize szText(0, 0);
			CString strText;
			strText.Format(_T("%s "), LoadStringFromResource(IDS_STRING462));	// 발신자:
			memDC.SetTextColor(CH_DLG_COLOR_STATIC_TEXT);
			memDC.DrawText(strText, &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
			szText = memDC.GetTextExtent(strText);

			if (!pCallData->strSendUserNm.empty())
			{
				rtText.OffsetRect(szText.cx, 0);
				strText.Format(_T("%s "), pCallData->strSendUserNm.c_str());		// 발신자명
				memDC.SetTextColor(CH_DLG_COLOR_NAME_TEXT);
				memDC.DrawText(strText, &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
				szText = memDC.GetTextExtent(strText);

				memDC.SelectObject(&g_ftDefault9PT);
				rtText.OffsetRect(szText.cx, 1);

				strText.Format(_T("%s/%s/%s [%s] %s"), pCallData->strSendJbpsNm.c_str(), pCallData->strSendJbdtNm.c_str(), pCallData->strSendDeptNm.c_str(), pCallData->strSendExtensionTelNo.c_str(), pCallData->strSendTelNo.c_str());
				memDC.SetTextColor(CH_DLG_COLOR_STATIC_TEXT);
				memDC.DrawText(strText, &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
				szText = memDC.GetTextExtent(strText);
			}
			else
			{
				rtText.OffsetRect(szText.cx, 0);
				strText.Format(_T("%s "), pCallData->strSendTelNo.c_str());	
				memDC.SetTextColor(CH_DLG_COLOR_NAME_TEXT);
				memDC.DrawText(strText, &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
			}

			memDC.SelectObject(&g_ftDefault9PT);
			rtText = CRect(30, 256, 480, 276);
			strText.Format(_T("%s "), LoadStringFromResource(IDS_STRING367));	// 수신자:
			memDC.SetTextColor(CH_DLG_COLOR_STATIC_TEXT);
			memDC.DrawText(strText, &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
			szText = memDC.GetTextExtent(strText);

			if (!pCallData->strRecvUserNm.empty())
			{
				rtText.OffsetRect(szText.cx, 0);
				strText.Format(_T("%s "), pCallData->strRecvUserNm.c_str());		// 수신자명
				memDC.SetTextColor(CH_DLG_COLOR_NAME_TEXT);
				memDC.DrawText(strText, &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
				szText = memDC.GetTextExtent(strText);

				memDC.SelectObject(&g_ftDefault9PT);
				rtText.OffsetRect(szText.cx, 1);
				strText.Format(_T("%s/%s/%s [%s] %s"), pCallData->strRecvJbpsNm.c_str(), pCallData->strRecvJbdtNm.c_str(), pCallData->strRecvDeptNm.c_str(), pCallData->strRecvExtensionTelNo.c_str(), pCallData->strRecvTelNo.c_str());
				memDC.SetTextColor(CH_DLG_COLOR_STATIC_TEXT);
				memDC.DrawText(strText, &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
				szText = memDC.GetTextExtent(strText);
			}
			else
			{
				rtText.OffsetRect(szText.cx, 0);
				strText.Format(_T("%s "), pCallData->strRecvTelNo.c_str());
				memDC.SetTextColor(CH_DLG_COLOR_NAME_TEXT);
				memDC.DrawText(strText, &rtText, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);
			}

		}
	}

	
	// 하단 안내문구
	CRect rtDot(0, 0, 3, 3);

	memDC.SelectObject(&g_ftDefault9PT);
	memDC.SetTextColor(CH_DLG_COLOR_STATIC_TEXT);

	rtDot.MoveToXY(20, 369);
	memDC.FillSolidRect(&rtDot, CH_DLG_COLOR_STATIC_TEXT);
	CString strPath;
	strPath.Format(LoadStringFromResource(IDS_STRING368), GetAppMemoDir());
	memDC.DrawText(strPath, CRect(30, 364, 480, 404), DT_LEFT | DT_NOPREFIX | DT_WORDBREAK);
	rtDot.MoveToXY(20, 407);
	memDC.FillSolidRect(&rtDot, CH_DLG_COLOR_STATIC_TEXT);
	memDC.DrawText(LoadStringFromResource(IDS_STRING369), CRect(30, 402, 480, 422), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);

	// 하단 가로선
	//memDC.MoveTo(0, rcClient.bottom - CH_DLG_BTN_HEIGHT - 17);
	//memDC.LineTo(rcClient.right, rcClient.bottom - CH_DLG_BTN_HEIGHT - 17);

	// memDC 에 그린 내용을 한번에 DC에 그려야 깜박임이 적다.
	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);	

	memDC.SelectObject(pOldPen);
	memDC.SelectObject(pOldFont);
}

BOOL CCallHistoryDlg::OnEraseBkgnd(CDC* pDC)
{

	return TRUE;
}

void CCallHistoryDlg::DeleteCallHistoryDataAll()
{
	for (int i = 0; i < m_lcCallHistory.GetItemCount(); i++)
	{
		NE_CALL_DATA* pCallData = (NE_CALL_DATA*)m_lcCallHistory.GetItemData(i);

		if (!pCallData)
			continue;

		delete pCallData;
		pCallData = NULL;
	}
	m_lcCallHistory.DeleteAllItems();
}

void CCallHistoryDlg::SetCallHistoryData(const std::vector<NE_CALL_DATA> &callData)
{
	DeleteCallHistoryDataAll();

	int nIndex = 0;

	std::vector<NE_CALL_DATA>::const_iterator callIter = callData.begin();

	for (; callIter != callData.end(); callIter++)
	{
		NE_CALL_DATA sCallData = *callIter;
		
		NE_CALL_DATA *pCallData = new NE_CALL_DATA;
		//memcpy(pCallData, &sCallData, sizeof(NE_CALL_DATA));
		
		pCallData->nCallSeq = sCallData.nCallSeq;
		pCallData->strSendUserId = sCallData.strSendUserId;
		pCallData->strSendUserNm = sCallData.strSendUserNm;
		pCallData->strSendDeptNm = sCallData.strSendDeptNm;
		pCallData->strSendJbpsNm = sCallData.strSendJbpsNm;
		pCallData->strSendJbdtNm = sCallData.strSendJbdtNm;
		pCallData->strSendExtensionTelNo = sCallData.strSendExtensionTelNo;
		pCallData->strSendTelNo = sCallData.strSendTelNo;
		pCallData->strRecvUserId = sCallData.strRecvUserId;
		pCallData->strRecvUserNm = sCallData.strRecvUserNm;
		pCallData->strRecvDeptNm = sCallData.strRecvDeptNm;
		pCallData->strRecvJbpsNm = sCallData.strRecvJbpsNm;
		pCallData->strRecvJbdtNm = sCallData.strRecvJbdtNm;
		pCallData->strRecvExtensionTelNo = sCallData.strRecvExtensionTelNo;
		pCallData->strRecvTelNo = sCallData.strRecvTelNo;
		pCallData->nStartYmdt = sCallData.nStartYmdt;
		pCallData->nEndYmdt = sCallData.nEndYmdt;

		LVITEM lvItem;
		lvItem.mask = LVIF_IMAGE;
		lvItem.iItem = nIndex;
		lvItem.iSubItem = CH_DLG_COLUMN_STATUS;

		if (pCallData->nEndYmdt == 0)
			lvItem.iImage = 2;	// 부재중
		else if (wcscmp(g_pMessengerActor->GetUserID(), pCallData->strSendUserId.c_str()) == 0)
			lvItem.iImage = 0;	// 발신전화
		else
			lvItem.iImage = 1;	// 수신전화

		m_lcCallHistory.InsertItem(&lvItem);

		CTime t(pCallData->nStartYmdt);
		//GetLocaleTime(&t);

		m_lcCallHistory.SetItemText(nIndex, CH_DLG_COLUMN_DATETIME, t.Format(_T("%Y-%m-%d %p %I:%M:%S")));

		CString strText;
		strText.Format(_T("%s [%s]"), pCallData->strSendUserNm.c_str(), pCallData->strSendTelNo.c_str());
		m_lcCallHistory.SetItemText(nIndex, CH_DLG_COLUMN_SENDER, strText);

		strText.Format(_T("%s [%s]"), pCallData->strRecvUserNm.c_str(), pCallData->strRecvTelNo.c_str());
		m_lcCallHistory.SetItemText(nIndex, CH_DLG_COLUMN_RECVER, strText);

		CString strMemoFileName = MakeMemoFileName(t, pCallData->strRecvUserNm.c_str());
		m_lcCallHistory.SetItemText(nIndex, CH_DLG_COLUMN_MEMO, GetMemo(strMemoFileName));
		m_lcCallHistory.SetItemData(nIndex, (DWORD_PTR)pCallData);

		nIndex++;
	}
}

CString CCallHistoryDlg::MakeMemoFileName(CTime time, CString strRecvNm)
{
	CString strMemoFileName = _T("");
	strMemoFileName.Format(_T("%s_%s.txt"), time.Format(_T("%Y%m%d%H%M%S")), strRecvNm);

	return strMemoFileName;
}

CString CCallHistoryDlg::GetMemo(CString strMemoFileName)
{
	CString strMemo = _T("");

	CString strFilePath;
	strFilePath.Format(_T("%s\\%s"), GetAppMemoDir(), strMemoFileName);

	CStdioFile file;
	
	if (file.Open(strFilePath, CFile::modeRead | CFile::shareDenyNone) == 0)
		return strMemo;

	CString strLine;
	int nLineCnt = 0;
	while (file.ReadString(strLine))
	{
		nLineCnt++;

		if (nLineCnt > 3)	// 3번째 줄 까지는 헤더로 간주한다
			strMemo += strLine + _T("\r\n");
		
	}

	file.Close();

	return strMemo;
}

bool CCallHistoryDlg::SaveMemo(CString strMemoFileName, CString strHeader, CString strMemo)
{
	CString strFilePath;
	strFilePath.Format(_T("%s\\%s"), GetAppMemoDir(), strMemoFileName);

	CStdioFile file;

	if (file.Open(strFilePath, CFile::modeCreate | CFile::modeWrite) == 0)
		return false;

	// Edit 컨트롤에서 줄바꿈을 \r\n 으로 처리하기 때문에 이 파일을 보통 에디터에서 볼 경우 빈줄이 두개 보이는 문제 때문에 아래 코드 삽입
	strMemo.Replace(_T("\r\n"), _T("\n"));

	file.WriteString(strHeader);
	file.WriteString(strMemo);

	file.Close();
	
	return true;
}

void CCallHistoryDlg::OnLvnItemchangedListCall(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	if (!(pNMLV->uChanged == LVIF_STATE && pNMLV->uNewState == (LVIS_SELECTED | LVIS_FOCUSED)))
		return;

	int nSelectItem = pNMLV->iItem;

	if (-1 == nSelectItem)
		return;

	m_editMemo.SetWindowText(m_lcCallHistory.GetItemText(nSelectItem, CH_DLG_COLUMN_MEMO));
	RedrawWindow(&m_rtMemo, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);

	*pResult = 0;
}

void CCallHistoryDlg::OnBnClickedBtnMemo()
{
	if (m_lcCallHistory.GetSelectedCount() != 1)
		return;

	POSITION pos = m_lcCallHistory.GetFirstSelectedItemPosition();
	int nSel = m_lcCallHistory.GetNextSelectedItem(pos);
	NE_CALL_DATA *pCallData = (NE_CALL_DATA*)m_lcCallHistory.GetItemData(nSel);

	CString strMemo;
	m_editMemo.GetWindowText(strMemo);

	CTime t(pCallData->nStartYmdt);
	//GetLocaleTime(&t);

	CString strMemoFileName = MakeMemoFileName(t, pCallData->strRecvUserNm.c_str());

	CString strSender;
	strSender.Format(_T("%s %s %s/%s/%s [%s] %s"), LoadStringFromResource(IDS_STRING462), pCallData->strSendUserNm.c_str(), pCallData->strSendJbpsNm.c_str(), 
		pCallData->strSendJbdtNm.c_str(), pCallData->strSendDeptNm.c_str(), pCallData->strSendExtensionTelNo.c_str(), pCallData->strSendTelNo.c_str());

	CString strRecver;
	strRecver.Format(_T("%s %s %s/%s/%s [%s] %s"), LoadStringFromResource(IDS_STRING367), pCallData->strRecvUserNm.c_str(), pCallData->strRecvJbpsNm.c_str(), 
		pCallData->strRecvJbdtNm.c_str(), pCallData->strRecvDeptNm.c_str(), pCallData->strRecvExtensionTelNo.c_str(), pCallData->strRecvTelNo.c_str());

	CString strHeader;
	strHeader.Format(_T("%s\n%s\n\n"), strSender, strRecver);

	if (SaveMemo(strMemoFileName, strHeader, strMemo))
	{
		m_lcCallHistory.SetItemText(nSel, CH_DLG_COLUMN_MEMO, strMemo);
		m_lcCallHistory.RedrawItems(nSel, nSel);
	}
}

void CCallHistoryDlg::UpdateMemo(int nCallSeq)
{
	for (int i = 0; i < m_lcCallHistory.GetItemCount(); i++)
	{
		int nItemCallSeq = m_lcCallHistory.GetItemData(i);

		if (nItemCallSeq != nCallSeq)
			continue;

		CString strMemo;
		m_editMemo.GetWindowText(strMemo);
		m_lcCallHistory.SetItemText(i, CH_DLG_COLUMN_MEMO, strMemo);
		m_lcCallHistory.RedrawItems(i, i);
	}
}

void CCallHistoryDlg::DoSearch(CString strSearchText)
{
	strSearchText = strSearchText.Trim(_T("% "));	// 앞뒤의 %와 공백 문자는 제거한다.

	if (strSearchText.GetLength() < 2)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING169));

		m_wndSearch.SetIntroducingText(m_wndSearch.GetSearchText());

		return;
	}

	m_wndSearch.SetIntroducingText(strSearchText);
	m_wndSearch.SetSearchText(strSearchText);

	NTCallType eCallType = callTypeAll;
	int nCbSel = m_cbSearchType.GetCurSel();

	switch (nCbSel)
	{
	case 0:
		eCallType = callTypeAll;
		break;
	case 1:
		eCallType = callTypeSend;
		break;
	case 2:
		eCallType = callTypeRecv;
		break;
	case 3:
		eCallType = callTypeAbsent;
		break;
	}

	m_pActorEvent->RequestSearchCallHistory(eCallType, strSearchText);
}

BOOL CCallHistoryDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int nID = LOWORD(wParam);

	switch (nID)
	{
	case ID_CALL_HISTORY_SEARCH:
		{
			CString strSearchText = m_wndSearch.GetSearchText();
			DoSearch(strSearchText);
		}
		break;
	}

	return __super::OnCommand(wParam, lParam);
}

void CCallHistoryDlg::OnBnClickedBtnClose()
{
	PostMessage(WM_ASYNC_DESTROYWINDOW, 0, 0);
}

void CCallHistoryDlg::OnBnClickedBtnCallTypeAll()
{
	m_pActorEvent->RequestCallHistory(callTypeAll);
}

void CCallHistoryDlg::OnBnClickedBtnCallTypeSend()
{
	m_pActorEvent->RequestCallHistory(callTypeSend);
}

void CCallHistoryDlg::OnBnClickedBtnCallTypeRecv()
{
	m_pActorEvent->RequestCallHistory(callTypeRecv);
}

void CCallHistoryDlg::OnBnClickedBtnCallTypeAbsent()
{
	m_pActorEvent->RequestCallHistory(callTypeAbsent);
}

void CCallHistoryDlg::OnDestroy()
{
	if(m_pOKCancelButtons)
	{
		::DestroyWindow(m_pOKCancelButtons->GetHWND());
		SAFE_DELETE(m_pOKCancelButtons);
	}

	__super::OnDestroy();

	DeleteCallHistoryDataAll();
}

int CCallHistoryDlg::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
	if (CSkinDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_pOKCancelButtons = new COKCancelButtons(this, this);
	m_pOKCancelButtons->LoadSkin();

	m_pOKCancelButtons->SetButtonText(LoadStringFromResource(IDS_STRING398), 
		LoadStringFromResource(IDS_STRING565));


	return 0;
}

void CCallHistoryDlg::OnButtonClicked( COKCancelButtons::BUTTONS button )
{
	ASSERT(button != COKCancelButtons::All);

	if(button == COKCancelButtons::OK)
	{
		OnBnClickedBtnMemo();
	}
	else if(button == COKCancelButtons::Cancle)
	{
		OnBnClickedBtnClose();
	}
	else
	{
		ASSERT(FALSE);
	}
}
